#include <stdio.h>
#include <stdlib.h>

#ifdef CRA_USE_TR1
#include <tr1/unordered_set>
using namespace std::tr1;
#else
#include <unordered_set>
using namespace std;
#endif

const int n = 320000;

struct Foo {
  int bar;
  int baz;
  int meh;
  Foo() { bar = random(); baz = random(); meh = random(); }
  size_t hash() const { return bar^baz^meh; }
  inline bool operator==(const Foo& other) const {
    return other.bar == bar && other.baz == baz && other.meh == meh;
  }
};

struct HashFunction {
  template<typename T>
  size_t operator()(const T& t) const {
    return t.hash();
  }
};

Foo foos[n];

extern "C" {
  void onerun()
  {
    unordered_set<Foo, HashFunction> foo;

    for (int i = 0; i < n; i++)
      foo.insert(foos[i]);
  }

  void callthis()
  {
    int repetitions = 400;
    for (int i = 0; i < repetitions; i++)
      onerun();
    fprintf(stderr, "meh: %d %d %lld\n"
	    , foos[200].bar, foos[5000].meh, (long long)foos[20].hash());
  }
}
